package main

import (
	"log"
	"os"

	"gitea.unprism.ru/KRBL/sim-modem/api/modem"
)

func main() {
	log.Println("CGSG forever!!!")
	if err := mainE(); err != nil {
		log.Println("MAIN finished with error:", err.Error())
	}
	log.Println("END")
}

func mainE() error {
	logger := log.New(os.Stdout, "main : ", log.LstdFlags)
	m := modem.New(log.New(logger.Writer(), "modem : ", log.LstdFlags))
	logger.Println("||||||||||||||||| INIT |||||||||||||||")
	if err := m.Init(); err != nil {
		logger.Println("Init ended with error:", err.Error())
		logger.Println("Try to turn on")
		if err := m.PowerOn(); err != nil {
			return err
		}
		logger.Println("Reinit")
		if err := m.Init(); err != nil {
			return err
		}
	}
	if !m.IsConnected() {
		logger.Println("AAAAAAAAAAAAAAA Modem is not connected")
		return nil
	}
	logger.Println("||||||||||||||||| GET INFO |||||||||||||||||")
	logger.Println(m.Update())
	logger.Printf("DATA: %+v\n", m.GetData())

	logger.Println("||||||||||||||||| SEND SMS |||||||||||||||||")
	logger.Println(m.At().Send("AT+CNUM"))
	// if err := m.Sms().Send("+79218937173", "CGSG forever"); err != nil {
	// 	return err
	// }
	if ms, err := m.Sms().ReadNew(); err != nil {
		return err
	} else {
		logger.Println("NEW:", ms)
	}
	logger.Println("||||||||||||||||| Checking gps status  |||||||||||||||||")
	st, err := m.Gps().GetStatus()
	if err != nil {
		return err
	}
	logger.Printf("GPS Status:%+v\n", st)

	// logger.Println("Turn off", m.PowerOff())

	return nil
}
